Index: NEMO/branches/UKMO/NEMO_4.0.4_FOAM_package/src/OCE/OBS/obs_read_surf.F90
===================================================================
--- NEMO/branches/UKMO/NEMO_4.0.4_FOAM_package/src/OCE/OBS/obs_read_surf.F90	(revision 15731)
+++ NEMO/branches/UKMO/NEMO_4.0.4_FOAM_package/src/OCE/OBS/obs_read_surf.F90	(revision 15799)
@@ -22,4 +22,7 @@
    USE obs_fbm                  ! Feedback routines
    USE netcdf                   ! NetCDF library
+   USE obs_group_def, ONLY : &  ! Observation variable information
+      & cobsname_uvel, &
+      & cobsname_vvel
 
    IMPLICIT NONE
@@ -39,6 +42,7 @@
 
    SUBROUTINE obs_rea_surf( surfdata, knumfiles, cdfilenames, &
-      &                     kvars, kextr, kstp, ddobsini, ddobsend, &
-      &                     ldignmis, ldmod, ldnightav )
+      &                     kvars, kadd, kextr, kstp, ddobsini, ddobsend, &
+      &                     ptime_mean_period, ld_time_mean_bkg, &
+      &                     ldignmis, ldmod, ldnightav, cdvars )
       !!---------------------------------------------------------------------
       !!
@@ -61,24 +65,47 @@
       !! * Arguments
       TYPE(obs_surf), INTENT(INOUT) :: &
-         & surfdata                     ! Surface data to be read
-      INTEGER, INTENT(IN) :: knumfiles  ! Number of corio format files to read
+         & surfdata                             ! Surface data to be read
+      INTEGER,  INTENT(IN) :: knumfiles         ! Number of corio format files to read
       CHARACTER(LEN=128), INTENT(IN) :: &
-         & cdfilenames(knumfiles)       ! File names to read in
-      INTEGER, INTENT(IN) :: kvars      ! Number of variables in surfdata
-      INTEGER, INTENT(IN) :: kextr      ! Number of extra fields for each var
-      INTEGER, INTENT(IN) :: kstp       ! Ocean time-step index
-      LOGICAL, INTENT(IN) :: ldignmis   ! Ignore missing files
-      LOGICAL, INTENT(IN) :: ldmod      ! Initialize model from input data
-      LOGICAL, INTENT(IN) :: ldnightav  ! Observations represent a night-time average
-      REAL(dp), INTENT(IN) :: ddobsini   ! Obs. ini time in YYYYMMDD.HHMMSS
-      REAL(dp), INTENT(IN) :: ddobsend   ! Obs. end time in YYYYMMDD.HHMMSS
+         & cdfilenames(knumfiles)               ! File names to read in
+      INTEGER,  INTENT(IN) :: kvars             ! Number of variables in surfdata
+      INTEGER,  INTENT(IN) :: kadd              ! Number of additional fields
+                                                !   in addition to those in the input file(s)
+      INTEGER,  INTENT(IN) :: kextr             ! Number of extra fields
+                                                !   in addition to those in the input file(s)
+      INTEGER,  INTENT(IN) :: kstp              ! Ocean time-step index
+      REAL(dp), INTENT(IN) :: ddobsini          ! Obs. ini time in YYYYMMDD.HHMMSS
+      REAL(dp), INTENT(IN) :: ddobsend          ! Obs. end time in YYYYMMDD.HHMMSS
+      REAL(wp), INTENT(IN) :: ptime_mean_period ! Averaging period in hours
+      LOGICAL,  INTENT(IN) :: ld_time_mean_bkg  ! Will reset times to end of averaging period
+      LOGICAL,  INTENT(IN) :: ldignmis          ! Ignore missing files
+      LOGICAL,  INTENT(IN) :: ldmod             ! Initialize model from input data
+      LOGICAL,  INTENT(IN) :: ldnightav         ! Observations represent a night-time average
+      CHARACTER(len=8), DIMENSION(kvars), INTENT(IN) :: cdvars  ! Expected variable names
 
       !! * Local declarations
       CHARACTER(LEN=11), PARAMETER :: cpname='obs_rea_surf'
       CHARACTER(len=8) :: clrefdate
-      CHARACTER(len=8), DIMENSION(:), ALLOCATABLE :: clvars
+      CHARACTER(len=ilenname), DIMENSION(:),   ALLOCATABLE :: clvarsin
+      CHARACTER(len=ilenlong), DIMENSION(:),   ALLOCATABLE :: cllongin
+      CHARACTER(len=ilenunit), DIMENSION(:),   ALLOCATABLE :: clunitin
+      CHARACTER(len=ilengrid), DIMENSION(:),   ALLOCATABLE :: clgridin
+      CHARACTER(len=ilenname), DIMENSION(:),   ALLOCATABLE :: claddvarsin
+      CHARACTER(len=ilenlong), DIMENSION(:,:), ALLOCATABLE :: claddlongin
+      CHARACTER(len=ilenunit), DIMENSION(:,:), ALLOCATABLE :: claddunitin
+      CHARACTER(len=ilenname), DIMENSION(:),   ALLOCATABLE :: clextvarsin
+      CHARACTER(len=ilenlong), DIMENSION(:),   ALLOCATABLE :: clextlongin
+      CHARACTER(len=ilenunit), DIMENSION(:),   ALLOCATABLE :: clextunitin
       INTEGER :: ji
       INTEGER :: jj
       INTEGER :: jk
+      INTEGER :: jind
+      INTEGER :: jvar
+      INTEGER :: jext
+      INTEGER :: jadd
+      INTEGER :: jadd2
+      INTEGER :: iadd
+      INTEGER :: iaddin
+      INTEGER :: iextr
       INTEGER :: iflag
       INTEGER :: inobf
@@ -102,8 +129,9 @@
          & ityp, &
          & itypmpp
-      INTEGER, DIMENSION(:), ALLOCATABLE :: &
+      INTEGER, DIMENSION(:,:), ALLOCATABLE :: &
          & iobsi,    &
          & iobsj,    &
-         & iproc,    &
+         & iproc
+      INTEGER, DIMENSION(:), ALLOCATABLE :: &
          & iindx,    &
          & ifileidx, &
@@ -120,4 +148,5 @@
       TYPE(obfbdata), POINTER, DIMENSION(:) :: &
          & inpfiles
+      CHARACTER(LEN=256) :: cout1  ! Diagnostic output line
 
       ! Local initialization
@@ -131,4 +160,7 @@
 
       ALLOCATE( inpfiles(inobf) )
+
+      iadd  = 0
+      iextr = 0
 
       surf_files : DO jj = 1, inobf
@@ -178,24 +210,120 @@
                &                ldgrid = .TRUE. )
 
+            IF ( inpfiles(jj)%nvar /= kvars ) THEN
+               CALL ctl_stop( 'Feedback format error: ', &
+                  &           ' unexpected number of vars in feedback file', &
+                  &           TRIM(cdfilenames(jj)) )
+            ENDIF
+
             IF ( ldmod .AND. ( inpfiles(jj)%nadd == 0 ) ) THEN
-               CALL ctl_stop( 'Model not in input data' )
+               CALL ctl_stop( 'Model not in input data in', &
+                  &           TRIM(cdfilenames(jj)) )
                RETURN
             ENDIF
 
+            IF ( (iextr > 0) .AND. (inpfiles(jj)%next /= iextr) ) THEN
+               CALL ctl_stop( 'Number of extra variables not consistent', &
+                  &           ' with previous files for this type in', &
+                  &           TRIM(cdfilenames(jj)) )
+            ELSE
+               iextr = inpfiles(jj)%next
+            ENDIF
+
+            ! Ignore model counterpart
+            iaddin = inpfiles(jj)%nadd
+            DO ji = 1, iaddin
+               IF ( TRIM(inpfiles(jj)%caddname(ji)) == 'Hx' ) THEN
+                  iaddin = iaddin - 1
+                  EXIT
+               ENDIF
+            END DO
+            IF ( ldmod .AND. ( inpfiles(jj)%nadd == iaddin ) ) THEN
+               CALL ctl_stop( 'Model not in input data', &
+                  &           TRIM(cdfilenames(jj)) )
+            ENDIF
+
+            IF ( (iadd > 0) .AND. (iaddin /= iadd) ) THEN
+               CALL ctl_stop( 'Number of additional variables not consistent', &
+                  &           ' with previous files for this type in', &
+                  &           TRIM(cdfilenames(jj)) )
+            ELSE
+               iadd = iaddin
+            ENDIF
+
             IF ( jj == 1 ) THEN
-               ALLOCATE( clvars( inpfiles(jj)%nvar ) )
+               ALLOCATE( clvarsin( inpfiles(jj)%nvar ) )
+               ALLOCATE( cllongin( inpfiles(jj)%nvar ) )
+               ALLOCATE( clunitin( inpfiles(jj)%nvar ) )
+               ALLOCATE( clgridin( inpfiles(jj)%nvar ) )
                DO ji = 1, inpfiles(jj)%nvar
-                 clvars(ji) = inpfiles(jj)%cname(ji)
+                 clvarsin(ji) = inpfiles(jj)%cname(ji)
+                 cllongin(ji) = inpfiles(jj)%coblong(ji)
+                 clunitin(ji) = inpfiles(jj)%cobunit(ji)
+                 clgridin(ji) = inpfiles(jj)%cgrid(ji)
+                 IF ( clvarsin(ji) /= cdvars(ji) ) THEN
+                    CALL ctl_stop( 'Feedback file variables do not match', &
+                        &           ' expected variable names for this type' )
+                 ENDIF
                END DO
+               IF ( iadd > 0 ) THEN
+                  ALLOCATE( claddvarsin( iadd ) )
+                  ALLOCATE( claddlongin( iadd, inpfiles(jj)%nvar ) )
+                  ALLOCATE( claddunitin( iadd, inpfiles(jj)%nvar ) )
+                  jadd = 0
+                  DO ji = 1, inpfiles(jj)%nadd
+                    IF ( TRIM(inpfiles(jj)%caddname(ji)) /= 'Hx' ) THEN
+                       jadd = jadd + 1
+                       claddvarsin(jadd) = inpfiles(jj)%caddname(ji)
+                       DO jk = 1, inpfiles(jj)%nvar
+                          claddlongin(jadd,jk) = inpfiles(jj)%caddlong(ji,jk)
+                          claddunitin(jadd,jk) = inpfiles(jj)%caddunit(ji,jk)
+                       END DO
+                    ENDIF
+                  END DO
+               ENDIF
+               IF ( iextr > 0 ) THEN
+                  ALLOCATE( clextvarsin( iextr ) )
+                  ALLOCATE( clextlongin( iextr ) )
+                  ALLOCATE( clextunitin( iextr ) )
+                  DO ji = 1, iextr
+                    clextvarsin(ji) = inpfiles(jj)%cextname(ji)
+                    clextlongin(ji) = inpfiles(jj)%cextlong(ji)
+                    clextunitin(ji) = inpfiles(jj)%cextunit(ji)
+                  END DO
+               ENDIF
             ELSE
                DO ji = 1, inpfiles(jj)%nvar
-                  IF ( inpfiles(jj)%cname(ji) /= clvars(ji) ) THEN
+                  IF ( inpfiles(jj)%cname(ji) /= clvarsin(ji) ) THEN
                      CALL ctl_stop( 'Feedback file variables not consistent', &
-                        &           ' with previous files for this type' )
+                        &           ' with previous files for this type in', &
+                        &           TRIM(cdfilenames(jj)) )
                   ENDIF
                END DO
-            ENDIF
-
-            IF (lwp) WRITE(numout,*)'Observation file contains ',inpfiles(jj)%nobs,' observations'
+               IF ( iadd > 0 ) THEN
+                  jadd = 0
+                  DO ji = 1, inpfiles(jj)%nadd
+                     IF ( TRIM(inpfiles(jj)%caddname(ji)) /= 'Hx' ) THEN
+                        jadd = jadd + 1
+                        IF ( inpfiles(jj)%caddname(ji) /= claddvarsin(jadd) ) THEN
+                           CALL ctl_stop( 'Feedback file additional variables not consistent', &
+                              &           ' with previous files for this type in', &
+                              &           TRIM(cdfilenames(jj)) )
+                        ENDIF
+                     ENDIF
+                  END DO
+               ENDIF
+               IF ( iextr > 0 ) THEN
+                  DO ji = 1, iextr
+                     IF ( inpfiles(jj)%cextname(ji) /= clextvarsin(ji) ) THEN
+                        CALL ctl_stop( 'Feedback file extra variables not consistent', &
+                           &           ' with previous files for this type in', &
+                           &           TRIM(cdfilenames(jj)) )
+                     ENDIF
+                  END DO
+               ENDIF
+
+            ENDIF
+
+            IF (lwp) WRITE(numout,*) 'Observation file contains ', inpfiles(jj)%nobs, ' observations'
 
             !------------------------------------------------------------------
@@ -247,8 +375,21 @@
 
             IF ( inpfiles(jj)%nobs > 0 ) THEN
-               inpfiles(jj)%iproc = -1
-               inpfiles(jj)%iobsi = -1
-               inpfiles(jj)%iobsj = -1
-            ENDIF
+               inpfiles(jj)%iproc(:,:) = -1
+               inpfiles(jj)%iobsi(:,:) = -1
+               inpfiles(jj)%iobsj(:,:) = -1
+            ENDIF
+
+            ! If observations are representing a time mean then set the time
+            ! of the obs to the end of that meaning period relative to the start of the run
+            IF ( ld_time_mean_bkg ) THEN
+               DO ji = 1, inpfiles(jj)%nobs
+                  ! Only do this for obs within time window
+                  IF ( ( inpfiles(jj)%ptim(ji) >  djulini(jj) ) .AND. &
+                     & ( inpfiles(jj)%ptim(ji) <= djulend(jj) ) ) THEN
+                     inpfiles(jj)%ptim(ji) = djulini(jj) + (ptime_mean_period/24.0)
+                  ENDIF
+               END DO
+            ENDIF
+
             inowin = 0
             DO ji = 1, inpfiles(jj)%nobs
@@ -258,9 +399,9 @@
                ENDIF
             END DO
-            ALLOCATE( zlam(inowin)  )
-            ALLOCATE( zphi(inowin)  )
-            ALLOCATE( iobsi(inowin) )
-            ALLOCATE( iobsj(inowin) )
-            ALLOCATE( iproc(inowin) )
+            ALLOCATE( zlam (inowin)       )
+            ALLOCATE( zphi (inowin)       )
+            ALLOCATE( iobsi(inowin,kvars) )
+            ALLOCATE( iobsj(inowin,kvars) )
+            ALLOCATE( iproc(inowin,kvars) )
             inowin = 0
             DO ji = 1, inpfiles(jj)%nobs
@@ -273,5 +414,27 @@
             END DO
 
-            CALL obs_grid_search( inowin, zlam, zphi, iobsi, iobsj, iproc, 'T' )
+            ! Do grid search
+            ! Assume anything other than velocity is on T grid
+            ! Save resource by not repeating for the same grid
+            jind = 0
+            DO jvar = 1, kvars
+               IF ( TRIM(inpfiles(jj)%cname(jvar)) == cobsname_uvel ) THEN
+                  CALL obs_grid_search( inowin, zlam, zphi, iobsi(:,jvar), iobsj(:,jvar), &
+                     &                  iproc(:,jvar), 'U' )
+               ELSE IF ( TRIM(inpfiles(jj)%cname(jvar)) == cobsname_vvel ) THEN
+                  CALL obs_grid_search( inowin, zlam, zphi, iobsi(:,jvar), iobsj(:,jvar), &
+                     &                  iproc(:,jvar), 'V' )
+               ELSE
+                  IF ( jind > 0 ) THEN
+                     iobsi(:,jvar) = iobsi(:,jind)
+                     iobsj(:,jvar) = iobsj(:,jind)
+                     iproc(:,jvar) = iproc(:,jind)
+                  ELSE
+                     jind = jvar
+                     CALL obs_grid_search( inowin, zlam, zphi, iobsi(:,jvar), iobsj(:,jvar), &
+                        &                  iproc(:,jvar), 'T' )
+                  ENDIF
+               ENDIF
+            END DO
 
             inowin = 0
@@ -280,7 +443,9 @@
                   & ( inpfiles(jj)%ptim(ji) <= djulend(jj) )       ) THEN
                   inowin = inowin + 1
-                  inpfiles(jj)%iproc(ji,1) = iproc(inowin)
-                  inpfiles(jj)%iobsi(ji,1) = iobsi(inowin)
-                  inpfiles(jj)%iobsj(ji,1) = iobsj(inowin)
+                  DO jvar = 1, kvars
+                     inpfiles(jj)%iproc(ji,jvar) = iproc(inowin,jvar)
+                     inpfiles(jj)%iobsi(ji,jvar) = iobsi(inowin,jvar)
+                     inpfiles(jj)%iobsj(ji,jvar) = iobsj(inowin,jvar)
+                  END DO
                ENDIF
             END DO
@@ -341,5 +506,5 @@
          &               iindx   )
 
-      CALL obs_surf_alloc( surfdata, iobs, kvars, kextr, kstp, jpi, jpj )
+      CALL obs_surf_alloc( surfdata, iobs, kvars, kadd+iadd, kextr+iextr, kstp, jpi, jpj )
 
       ! Read obs/positions, QC, all variable and assign to surfdata
@@ -347,5 +512,18 @@
       iobs = 0
 
-      surfdata%cvars(:)  = clvars(:)
+      surfdata%cvars(:)  = clvarsin(:)
+      surfdata%clong(:)  = cllongin(:)
+      surfdata%cunit(:)  = clunitin(:)
+      surfdata%cgrid(:)  = clgridin(:)
+      IF ( iadd > 0 ) THEN
+         surfdata%caddvars(kadd+1:)   = claddvarsin(:)
+         surfdata%caddlong(kadd+1:,:) = claddlongin(:,:)
+         surfdata%caddunit(kadd+1:,:) = claddunitin(:,:)
+      ENDIF
+      IF ( iextr > 0 ) THEN
+         surfdata%cextvars(kextr+1:) = clextvarsin(:)
+         surfdata%cextlong(kextr+1:) = clextlongin(:)
+         surfdata%cextunit(kextr+1:) = clextunitin(:)
+      ENDIF
 
       ityp   (:) = 0
@@ -395,6 +573,8 @@
 
                ! Coordinate search parameters
-               surfdata%mi  (iobs) = inpfiles(jj)%iobsi(ji,1)
-               surfdata%mj  (iobs) = inpfiles(jj)%iobsj(ji,1)
+               DO jvar = 1, kvars
+                  surfdata%mi(iobs,jvar) = inpfiles(jj)%iobsi(ji,jvar)
+                  surfdata%mj(iobs,jvar) = inpfiles(jj)%iobsj(ji,jvar)
+               END DO
 
                ! WMO number
@@ -415,6 +595,6 @@
                   ityp(itype+1) = ityp(itype+1) + 1
                ELSE
-                  IF(lwp)WRITE(numout,*)'WARNING:Increase jpsurfmaxtype in ',&
-                     &                  cpname
+                  IF(lwp)WRITE(numout,*) 'WARNING: Increase jpsurfmaxtype in ', &
+                     &                   cpname
                ENDIF
 
@@ -423,21 +603,36 @@
                surfdata%nsfil(iobs) = iindx(jk)
 
-               ! QC flags
-               surfdata%nqc(iobs) = inpfiles(jj)%ivqc(ji,1)
-
-               ! Observed value
-               surfdata%robs(iobs,1) = inpfiles(jj)%pob(1,ji,1)
-
-
-               ! Model and MDT is set to fbrmdi unless read from file
-               IF ( ldmod ) THEN
-                  surfdata%rmod(iobs,1) = inpfiles(jj)%padd(1,ji,1,1)
-                  IF ( TRIM(surfdata%cvars(1)) == 'SLA' ) THEN
-                     surfdata%rext(iobs,1) = inpfiles(jj)%padd(1,ji,2,1)
-                     surfdata%rext(iobs,2) = inpfiles(jj)%pext(1,ji,1)
+               DO jvar = 1, kvars
+
+                  ! QC flags
+                  surfdata%nqc(iobs) = inpfiles(jj)%ivqc(ji,jvar)
+
+                  ! Observed value
+                  surfdata%robs(iobs,jvar) = inpfiles(jj)%pob(1,ji,jvar)
+
+                  ! Additional variables
+                  surfdata%rmod(iobs,jvar) = fbrmdi
+                  IF ( iadd > 0 ) THEN
+                     jadd2 = 0
+                     DO jadd = 1, inpfiles(jj)%nadd
+                        IF ( TRIM(inpfiles(jj)%caddname(jadd)) == 'Hx' ) THEN
+                           IF ( ldmod ) THEN
+                              surfdata%rmod(iobs,jvar) = inpfiles(jj)%padd(1,ji,jadd,jvar)
+                           ENDIF
+                        ELSE
+                           jadd2 = jadd2 + 1
+                           surfdata%radd(iobs,kadd+jadd2,jvar) = &
+                              &                inpfiles(jj)%padd(1,ji,jadd,jvar)
+                        ENDIF
+                     END DO
                   ENDIF
-                ELSE
-                  surfdata%rmod(iobs,1) = fbrmdi
-                  IF ( TRIM(surfdata%cvars(1)) == 'SLA' ) surfdata%rext(iobs,:) = fbrmdi
+
+               END DO
+                  
+               ! Extra variables
+               IF ( iextr > 0 ) THEN
+                  DO jext = 1, iextr
+                     surfdata%rext(iobs,kextr+jext) = inpfiles(jj)%pext(1,ji,jext)
+                  END DO
                ENDIF
             ENDIF
@@ -457,11 +652,18 @@
       !-----------------------------------------------------------------------
       IF (lwp) THEN
-
+         DO jvar = 1, surfdata%nvar       
+            IF ( jvar == 1 ) THEN
+               cout1=TRIM(surfdata%cvars(1))                  
+            ELSE
+               WRITE(cout1,'(A,A1,A)') TRIM(cout1), '/', TRIM(surfdata%cvars(jvar))            
+            ENDIF
+         END DO
+ 
          WRITE(numout,*)
-         WRITE(numout,'(1X,A)')TRIM( surfdata%cvars(1) )//' data'
+         WRITE(numout,'(1X,A)')TRIM( cout1 )//' data'
          WRITE(numout,'(1X,A)')'--------------'
          DO jj = 1,8
             IF ( itypmpp(jj) > 0 ) THEN
-               WRITE(numout,'(1X,A4,I4,A3,I10)')'Type ', jj,' = ',itypmpp(jj)
+               WRITE(numout,'(1X,A4,I4,A3,I10)') 'Type ', jj, ' = ', itypmpp(jj)
             ENDIF
          END DO
@@ -469,5 +671,5 @@
             & '---------------------------------------------------------------'
          WRITE(numout,'(1X,A,I8)') &
-            & 'Total data for variable '//TRIM( surfdata%cvars(1) )// &
+            & 'Total data for variable '//TRIM( cout1 )// &
             & '           = ', iobsmpp
          WRITE(numout,'(1X,A)') &
@@ -480,5 +682,12 @@
       ! Deallocate temporary data
       !-----------------------------------------------------------------------
-      DEALLOCATE( ifileidx, isurfidx, zdat, clvars )
+      DEALLOCATE( ifileidx, isurfidx, zdat, clvarsin, &
+         &        cllongin, clunitin, clgridin )
+      IF ( iadd > 0 ) THEN
+         DEALLOCATE( claddvarsin, claddlongin, claddunitin)
+      ENDIF
+      IF ( iextr > 0 ) THEN
+         DEALLOCATE( clextvarsin, clextlongin, clextunitin )
+      ENDIF
 
       !-----------------------------------------------------------------------
Index: NEMO/branches/UKMO/NEMO_4.0.4_FOAM_package/src/OCE/OBS/obs_readmdt.F90
===================================================================
--- NEMO/branches/UKMO/NEMO_4.0.4_FOAM_package/src/OCE/OBS/obs_readmdt.F90	(revision 15731)
+++ NEMO/branches/UKMO/NEMO_4.0.4_FOAM_package/src/OCE/OBS/obs_readmdt.F90	(revision 15799)
@@ -31,9 +31,4 @@
    
    PUBLIC   obs_rea_mdt     ! called by dia_obs_init
-   PUBLIC   obs_offset_mdt  ! called by obs_rea_mdt
-
-   INTEGER , PUBLIC :: nn_msshc    = 1         ! MDT correction scheme
-   REAL(wp), PUBLIC :: rn_mdtcorr   = 1.61_wp  ! User specified MDT correction
-   REAL(wp), PUBLIC :: rn_mdtcutoff = 65.0_wp  ! MDT cutoff for computed correction
 
    !!----------------------------------------------------------------------
@@ -44,5 +39,6 @@
 CONTAINS
 
-   SUBROUTINE obs_rea_mdt( sladata, k2dint )
+   SUBROUTINE obs_rea_mdt( sladata, k2dint, kmdt, nn_msshc, rn_mdtcorr, &
+                           rn_mdtcutoff )
       !!---------------------------------------------------------------------
       !!
@@ -57,6 +53,10 @@
       USE iom
       !
-      TYPE(obs_surf), INTENT(inout) ::   sladata   ! SLA data
-      INTEGER       , INTENT(in)    ::   k2dint    ! ?
+      TYPE(obs_surf), INTENT(inout) :: sladata      ! SLA data
+      INTEGER       , INTENT(in)    :: k2dint       ! Interpolation type
+      INTEGER       , INTENT(in)    :: kmdt         ! Index of MDT extra var
+      INTEGER       , INTENT(in)    :: nn_msshc     ! MDT correction scheme
+      REAL(wp)      , INTENT(in)    :: rn_mdtcorr   ! User specified MDT correction
+      REAL(wp)      , INTENT(in)    :: rn_mdtcutoff ! MDT cutoff for computed correction
       !
       CHARACTER(LEN=12), PARAMETER ::   cpname  = 'obs_rea_mdt'
@@ -105,9 +105,11 @@
 
       ! Remove the offset between the MDT used with the sla and the model MDT
-      IF( nn_msshc == 1 .OR. nn_msshc == 2 ) &
-         & CALL obs_offset_mdt( jpi, jpj, z_mdt, zfill )
-
-      ! Intepolate the MDT already on the model grid at the observation point
-  
+      IF( nn_msshc == 1 .OR. nn_msshc == 2 ) THEN
+         CALL obs_offset_mdt( jpi, jpj, z_mdt, zfill, nn_msshc, &
+            &                 rn_mdtcorr, rn_mdtcutoff )
+      ENDIF
+
+      ! Interpolate the MDT already on the model grid at the observation point
+
       ALLOCATE( &
          & igrdi(2,2,sladata%nsurf), &
@@ -118,5 +120,5 @@
          & zmdtl(2,2,sladata%nsurf)  &
          & )
-         
+
       DO jobs = 1, sladata%nsurf
 
@@ -147,12 +149,12 @@
             
          CALL obs_int_h2d( 1, 1, zweig, zmdtl(:,:,jobs),  zext )
- 
-         sladata%rext(jobs,2) = zext(1)
+
+         sladata%rext(jobs,kmdt) = zext(1)
 
 ! mark any masked data with a QC flag
          IF( zobsmask(1) == 0 )   sladata%nqc(jobs) = IBSET(sladata%nqc(jobs),15)
 
-         END DO
-         
+      END DO
+
       DEALLOCATE( &
          & igrdi, &
@@ -169,5 +171,6 @@
 
 
-   SUBROUTINE obs_offset_mdt( kpi, kpj, mdt, zfill )
+   SUBROUTINE obs_offset_mdt( kpi, kpj, mdt, zfill, nn_msshc, rn_mdtcorr, &
+                              rn_mdtcutoff )
       !!---------------------------------------------------------------------
       !!
@@ -183,6 +186,9 @@
       !!----------------------------------------------------------------------
       INTEGER, INTENT(IN) ::  kpi, kpj
-      REAL(wp), DIMENSION(kpi,kpj), INTENT(INOUT) ::   mdt     ! MDT used on the model grid
-      REAL(wp)                    , INTENT(IN   ) ::   zfill 
+      REAL(wp), DIMENSION(kpi,kpj), INTENT(INOUT) :: mdt          ! MDT used on the model grid
+      REAL(wp)                    , INTENT(IN   ) :: zfill        ! Fill value
+      INTEGER                     , INTENT(IN   ) :: nn_msshc     ! MDT correction scheme
+      REAL(wp)                    , INTENT(IN   ) :: rn_mdtcorr   ! User specified MDT correction
+      REAL(wp)                    , INTENT(IN   ) :: rn_mdtcutoff ! MDT cutoff for computed correction
       ! 
       INTEGER  :: ji, jj
@@ -246,9 +252,9 @@
          WRITE(numout,*) '               zcorr         = ', zcorr
          WRITE(numout,*) '               nn_msshc        = ', nn_msshc
+
+         IF ( nn_msshc == 0 ) WRITE(numout,*) '           MSSH correction is not applied'
+         IF ( nn_msshc == 1 ) WRITE(numout,*) '           MSSH correction is applied'
+         IF ( nn_msshc == 2 ) WRITE(numout,*) '           User defined MSSH correction' 
       ENDIF
-
-      IF ( nn_msshc == 0 ) WRITE(numout,*) '           MSSH correction is not applied'
-      IF ( nn_msshc == 1 ) WRITE(numout,*) '           MSSH correction is applied'
-      IF ( nn_msshc == 2 ) WRITE(numout,*) '           User defined MSSH correction' 
 
       !
Index: NEMO/branches/UKMO/NEMO_4.0.4_FOAM_package/src/OCE/OBS/obs_readsnowdepth.F90
===================================================================
--- NEMO/branches/UKMO/NEMO_4.0.4_FOAM_package/src/OCE/OBS/obs_readsnowdepth.F90	(revision 15799)
+++ NEMO/branches/UKMO/NEMO_4.0.4_FOAM_package/src/OCE/OBS/obs_readsnowdepth.F90	(revision 15799)
@@ -0,0 +1,146 @@
+MODULE obs_readsnowdepth
+   !!======================================================================
+   !!                       ***  MODULE obs_readsnowdepth  ***
+   !! Observation diagnostics: Get the snow depth for freeboard conversion to thickness
+   !!======================================================================
+   !! History :      ! 2018-10 (E. Fiedler) Initial version
+   !!----------------------------------------------------------------------
+
+   !!----------------------------------------------------------------------
+   !!   obs_rea_snowdepth    : Driver for reading MDT
+   !!----------------------------------------------------------------------
+   USE par_kind         ! Precision variables
+   USE par_oce          ! Domain parameters
+   USE in_out_manager   ! I/O manager
+   USE obs_surf_def     ! Surface observation definitions
+   USE obs_inter_sup    ! Interpolation support routines
+   USE obs_inter_h2d    ! 2D interpolation
+   USE obs_utils        ! Various observation tools
+   USE iom_nf90         ! IOM NetCDF
+   USE netcdf           ! NetCDF library
+   USE lib_mpp          ! MPP library
+   USE dom_oce, ONLY : &                  ! Domain variables
+      &                    tmask, tmask_i, e1t, e2t, gphit, glamt
+   USE obs_const, ONLY :   obfillflt      ! Fillvalue
+
+   IMPLICIT NONE
+   PRIVATE
+   
+   PUBLIC   obs_rea_snowdepth     ! called by dia_obs
+
+   !!----------------------------------------------------------------------
+   !! NEMO/OPA 3.3 , NEMO Consortium (2010)
+   !! $Id$
+   !! Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
+   !!----------------------------------------------------------------------
+CONTAINS
+
+   SUBROUTINE obs_rea_snowdepth( fbddata, k2dint, ksnow, thick_s )
+      !!---------------------------------------------------------------------
+      !!
+      !!                   *** ROUTINE obs_rea_snowdepth ***
+      !!
+      !! ** Purpose : Get snowdepth at observation points
+      !!
+      !! ** Method  : 
+      !!
+      !! ** Action  : 
+      !!----------------------------------------------------------------------
+      USE iom
+      !
+      TYPE(obs_surf), INTENT(inout)  ::   fbddata   ! Sea ice freeboard data
+      INTEGER       , INTENT(in)     ::   k2dint    ! ?
+      INTEGER       , INTENT(in)    ::    ksnow     ! Index of snow thickness extra var
+      REAL(wp), INTENT(IN), DIMENSION(jpi,jpj) :: thick_s ! Model snow depth
+     
+      CHARACTER(LEN=12), PARAMETER ::   cpname  = 'obs_rea_snowdepth'
+
+      INTEGER ::   jobs                ! Obs loop variable
+      INTEGER ::   jpi_thick_s, jpj_thick_s      ! Number of grid point in lat/lon for the snow depth
+      INTEGER ::   iico, ijco          ! Grid point indices
+
+      !
+      REAL(wp), DIMENSION(1)     ::   zext, zobsmask
+      REAL(wp), DIMENSION(2,2,1) ::   zweig
+      !
+      REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::   zmask, z_thick_s_l, zglam, zgphi
+      INTEGER , DIMENSION(:,:,:), ALLOCATABLE ::   igrdi, igrdj
+      !
+      REAL(wp), DIMENSION(jpi,jpj) ::  z_thick_s, thick_s_mask
+         
+      REAL(wp) :: zlam, zphi, zfill, zinfill    ! local scalar
+      !!----------------------------------------------------------------------
+
+      IF(lwp)WRITE(numout,*) 
+      IF(lwp)WRITE(numout,*) ' obs_rea_snowdepth : Get model snow depth for freeboard conversion to sea ice thickness'
+      IF(lwp)WRITE(numout,*) ' ------------- '
+      CALL FLUSH(numout)
+
+      ! Get ice thickness information
+      z_thick_s = thick_s
+
+      ! Setup mask based on tmask
+      thick_s_mask(:,:) = tmask(:,:,1)
+
+      ! Interpolate the snow depth already on the model grid at the observation point
+  
+      ALLOCATE( &
+         & igrdi(2,2,fbddata%nsurf), &
+         & igrdj(2,2,fbddata%nsurf), &
+         & zglam(2,2,fbddata%nsurf), &
+         & zgphi(2,2,fbddata%nsurf), &
+         & zmask(2,2,fbddata%nsurf), &
+         & z_thick_s_l(2,2,fbddata%nsurf)  &
+         & )
+         
+      DO jobs = 1, fbddata%nsurf
+
+         igrdi(1,1,jobs) = fbddata%mi(jobs)-1
+         igrdj(1,1,jobs) = fbddata%mj(jobs)-1
+         igrdi(1,2,jobs) = fbddata%mi(jobs)-1
+         igrdj(1,2,jobs) = fbddata%mj(jobs)
+         igrdi(2,1,jobs) = fbddata%mi(jobs)
+         igrdj(2,1,jobs) = fbddata%mj(jobs)-1
+         igrdi(2,2,jobs) = fbddata%mi(jobs)
+         igrdj(2,2,jobs) = fbddata%mj(jobs)
+
+      END DO
+
+      CALL obs_int_comm_2d( 2, 2, fbddata%nsurf, jpi, jpj, igrdi, igrdj, glamt  , zglam )
+      CALL obs_int_comm_2d( 2, 2, fbddata%nsurf, jpi, jpj, igrdi, igrdj, gphit  , zgphi )
+      CALL obs_int_comm_2d( 2, 2, fbddata%nsurf, jpi, jpj, igrdi, igrdj, thick_s_mask, zmask )
+      CALL obs_int_comm_2d( 2, 2, fbddata%nsurf, jpi, jpj, igrdi, igrdj, z_thick_s  , z_thick_s_l )
+
+      DO jobs = 1, fbddata%nsurf
+            
+         zlam = fbddata%rlam(jobs)
+         zphi = fbddata%rphi(jobs)
+
+         CALL obs_int_h2d_init( 1, 1, k2dint, zlam, zphi,         &
+            &                   zglam(:,:,jobs), zgphi(:,:,jobs), &
+            &                   zmask(:,:,jobs), zweig, zobsmask )
+            
+         CALL obs_int_h2d( 1, 1, zweig, z_thick_s_l(:,:,jobs),  zext )
+ 
+         fbddata%rext(jobs,ksnow) = zext(1)
+
+! mark any masked data with a QC flag
+         IF( zobsmask(1) == 0 )   fbddata%nqc(jobs) = IBSET(fbddata%nqc(jobs),15)
+
+         END DO
+         
+      DEALLOCATE( &
+         & igrdi, &
+         & igrdj, &
+         & zglam, &
+         & zgphi, &
+         & zmask, &
+         & z_thick_s_l  &
+         & )
+
+      IF(lwp)WRITE(numout,*) ' ------------- '
+      !
+   END SUBROUTINE obs_rea_snowdepth
+   
+   !!======================================================================
+END MODULE obs_readsnowdepth
